
prompt = {'Enter filename for photogate output','Threshold (0.3 or 1.0)'};
dlgtitle = 'Input';
dims = [1 35];
answer = inputdlg(prompt,dlgtitle,dims);

data=load(answer{1});
thresh=str2double(answer{2});



%remove the first point
data=data(2:end,:);
time=data(:,1); photo=data(:,2);
photo2=zeros(length(photo),1);

%converting the photogtae signal into a sequence of ones and zeros with a
%threshold of 1 V
for k=1:length(photo)
if photo(k)<thresh
    photo2(k)=0;
else
    photo2(k)=1;
end
end

%finding the indices where the transtitions from 0->1 and 1->0) occur
ind1=find(diff(photo2)==1);
ind2=find(diff(photo2)==-1);

%accounting for the data stream of binaries ending in a one instead of a
%zero

if length(ind1)>length(ind2)
ind1=ind1(1:end-1);
end

%Ensuring that the photogate output always starts with a zero

if length(ind1)<length(ind2)
ind2=ind2(1:end-1);
end


ind=[ind1 ind2];

%finding the intervals between successive crossings
ds1=diff(time(ind1+1));
ds2=diff(time(ind2));
dsfilt=sgolayfilt(ds1,7,11); %filtering the time intervals using Solvay Golay
omega=10*pi/(180)*1./dsfilt; %separation between two edges is 4+6=10 degrees

%finding the time where the average angular velocities are applicable
ind_avg=zeros(length(ind1)-1,1);
for k=1:length(ind1)-1
ind_avg(k)=round((ind1(k)+ind1(k+1))/2);
end
time_avg=time(ind_avg);

figure; plot(time_avg,omega), xlabel('time (s)'); ylabel('omega (rad/s)');
